org.apache.commons.io

## Class FilenameUtils

- java.lang.Object
- - org.apache.commons.io.FilenameUtils

-     public class FilenameUtils
      extends Object

  General file name and file path manipulation utilities. The methods in this class operate on strings that represent relative or absolute paths. Nothing in this class ever accesses the file system, or depends on whether a path points to a file that exists.

  When dealing with file names, you can hit problems when moving from a Windows based development machine to a Unix based production machine. This class aims to help avoid those problems.

  NOTE: You may be able to avoid using this class entirely simply by using JDK `File` objects and the two argument constructor `File(File,String)`.

  Most methods in this class are designed to work the same on both Unix and Windows. Those that don't include 'System', 'Unix', or 'Windows' in their name.

  Most methods recognize both separators (forward and backslashes), and both sets of prefixes. See the Javadoc of each method for details.

  This class defines six components within a path (sometimes called a file name or a full file name). Given an absolute Windows path such as C:\dev\project\file.txt they are:

  - the full file name, or just file name - C:\dev\project\file.txt
  - the prefix - C:\
  - the path - dev\project\
  - the full path - C:\dev\project\
  - the name - file.txt
  - the base name - file
  - the extension - txt

  Given an absolute Unix path such as /dev/project/file.txt they are:

  - the full file name, or just file name - /dev/project/file.txt
  - the prefix - /
  - the path - dev/project
  - the full path - /dev/project
  - the name - file.txt
  - the base name - file
  - the extension - txt

  Given a relative Windows path such as dev\project\file.txt they are:

  - the full file name, or just file name - dev\project\file.txt
  - the prefix - null
  - the path - dev\project\
  - the full path - dev\project\
  - the name - file.txt
  - the base name - file
  - the extension - txt

  Given an absolute Unix path such as /dev/project/file.txt they are:

  - the full path, full file name, or just file name - /dev/project/file.txt
  - the prefix - /
  - the path - dev/project
  - the full path - /dev/project
  - the name - file.txt
  - the base name - file
  - the extension - txt

  This class works best if directory names end with a separator. If you omit the last separator, it is impossible to determine if the last component corresponds to a file or a directory. This class treats final components that do not end with a separator as files, not directories.

  This class only supports Unix and Windows style names. Prefixes are matched as follows:

       Windows:
       a\b\c.txt           --> ""          --> relative
       \a\b\c.txt          --> "\"         --> current drive absolute
       C:a\b\c.txt         --> "C:"        --> drive relative
       C:\a\b\c.txt        --> "C:\"       --> absolute
       \\server\a\b\c.txt  --> "\\server\" --> UNC

       Unix:
       a/b/c.txt           --> ""          --> relative
       /a/b/c.txt          --> "/"         --> absolute
       ~/a/b/c.txt         --> "~/"        --> current user
       ~                   --> "~/"        --> current user (slash added)
       ~user/a/b/c.txt     --> "~user/"    --> named user
       ~user               --> "~user/"    --> named user (slash added)

  Both prefix styles are matched, irrespective of the machine that you are currently running on.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static char` | `EXTENSION_SEPARATOR` The extension separator character.
    `static String` | `EXTENSION_SEPARATOR_STR` The extension separator String.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static String` | `concat(String basePath, String fullFileNameToAdd)` Concatenates a fileName to a base path using normal command line style rules.
    `static boolean` | `directoryContains(String canonicalParent, String canonicalChild)` Determines whether the `parent` directory contains the `child` (a file or directory).
    `static boolean` | `equals(String fileName1, String fileName2)` Checks whether two file names are exactly equal.
    `static boolean` | `equals(String fileName1, String fileName2, boolean normalize, IOCase ioCase)` Checks whether two file names are equal, optionally normalizing and providing control over the case-sensitivity.
    `static boolean` | `equalsNormalized(String fileName1, String fileName2)` Checks whether two file names are equal after both have been normalized.
    `static boolean` | `equalsNormalizedOnSystem(String fileName1, String fileName2)` Checks whether two file names are equal using the case rules of the system after both have been normalized.
    `static boolean` | `equalsOnSystem(String fileName1, String fileName2)` Checks whether two file names are equal using the case rules of the system.
    `(package private) static char` | `flipSeparator(char ch)` Flips the Windows name separator to Linux and vice-versa.
    `static String` | `getBaseName(String fileName)` Gets the base name, minus the full path and extension, from a full file name.
    `static String` | `getExtension(String fileName)` Gets the extension of a file name.
    `static String` | `getFullPath(String fileName)` Gets the full path (prefix + path) from a full file name.
    `static String` | `getFullPathNoEndSeparator(String fileName)` Gets the full path (prefix + path) from a full file name, excluding the final directory separator.
    `static String` | `getName(String fileName)` Gets the name minus the path from a full file name.
    `static String` | `getPath(String fileName)` Gets the path from a full file name, which excludes the prefix and the name.
    `static String` | `getPathNoEndSeparator(String fileName)` Gets the path (which excludes the prefix) from a full file name, and also excluding the final directory separator.
    `static String` | `getPrefix(String fileName)` Gets the prefix such as `C:/` or `~/` from a full file name,
    `static int` | `getPrefixLength(String fileName)` Returns the length of the file name prefix, such as `C:/` or `~/`.
    `static int` | `indexOfExtension(String fileName)` Returns the index of the last extension separator character, which is a period.
    `static int` | `indexOfLastSeparator(String fileName)` Returns the index of the last directory separator character.
    `static boolean` | `isExtension(String fileName, Collection<String> extensions)` Checks whether the extension of the file name is one of those specified.
    `static boolean` | `isExtension(String fileName, String... extensions)` Checks whether the extension of the file name is one of those specified.
    `static boolean` | `isExtension(String fileName, String extension)` Checks whether the extension of the file name is that specified.
    `(package private) static boolean` | `isSystemWindows()` Determines if Windows file system is in use.
    `static String` | `normalize(String fileName)` Normalizes a path, removing double and single period path steps.
    `static String` | `normalize(String fileName, boolean unixSeparator)` Normalizes a path, removing double and single period path steps.
    `static String` | `normalizeNoEndSeparator(String fileName)` Normalizes a path, removing double and single period path steps, and removing any final directory separator.
    `static String` | `normalizeNoEndSeparator(String fileName, boolean unixSeparator)` Normalizes a path, removing double and single period path steps, and removing any final directory separator.
    `static String` | `removeExtension(String fileName)` Removes the extension from a fileName.
    `static String` | `separatorsToSystem(String path)` Converts all separators to the system separator.
    `static String` | `separatorsToUnix(String path)` Converts all separators to the Unix separator of forward slash.
    `static String` | `separatorsToWindows(String path)` Converts all separators to the Windows separator of backslash.
    `(package private) static String[]` | `splitOnTokens(String text)` Splits a string into a number of tokens.
    `static boolean` | `wildcardMatch(String fileName, String wildcardMatcher)` Checks a fileName to see if it matches the specified wildcard matcher, always testing case-sensitive.
    `static boolean` | `wildcardMatch(String fileName, String wildcardMatcher, IOCase ioCase)` Checks a fileName to see if it matches the specified wildcard matcher allowing control over case-sensitivity.
    `static boolean` | `wildcardMatchOnSystem(String fileName, String wildcardMatcher)` Checks a fileName to see if it matches the specified wildcard matcher using the case rules of the system.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### EXTENSION_SEPARATOR

          public static final char EXTENSION_SEPARATOR

      The extension separator character.
      See Also:
        Constant Field Values

    - #### EXTENSION_SEPARATOR_STR

          public static final String EXTENSION_SEPARATOR_STR

      The extension separator String.

  - ### Method Detail

    - #### concat

          public static String concat(String basePath,
                                      String fullFileNameToAdd)

      Concatenates a fileName to a base path using normal command line style rules.

      The effect is equivalent to resultant directory after changing directory to the first argument, followed by changing directory to the second argument.

      The first argument is the base path, the second is the path to concatenate. The returned path is always normalized via `normalize(String)`, thus `..` is handled.

      If `pathToAdd` is absolute (has an absolute prefix), then it will be normalized and returned. Otherwise, the paths will be joined, normalized and returned.

      The output will be the same on both Unix and Windows except for the separator character.

           /foo/      + bar        -->  /foo/bar
           /foo       + bar        -->  /foo/bar
           /foo       + /bar       -->  /bar
           /foo       + C:/bar     -->  C:/bar
           /foo       + C:bar      -->  C:bar [1]
           /foo/a/    + ../bar     -->  /foo/bar
           /foo/      + ../../bar  -->  null
           /foo/      + /bar       -->  /bar
           /foo/..    + /bar       -->  /bar
           /foo       + bar/c.txt  -->  /foo/bar/c.txt
           /foo/c.txt + bar        -->  /foo/c.txt/bar [2]

      [1] Note that the Windows relative drive prefix is unreliable when used with this method.

      [2] Note that the first parameter must be a path. If it ends with a name, then the name will be built into the concatenated path. If this might be a problem, use `getFullPath(String)` on the base path argument.

      Parameters:
        `basePath` - the base path to attach to, always treated as a path
        `fullFileNameToAdd` - the file name (or path) to attach to the base
      Returns:
        the concatenated path, or null if invalid
      Throws:
        `IllegalArgumentException` - if the result path contains the null character (`U+0000`)

    - #### directoryContains

          public static boolean directoryContains(String canonicalParent,
                                                  String canonicalChild)

      Determines whether the `parent` directory contains the `child` (a file or directory). This does not read from the file system, and there is no guarantee or expectation that these paths actually exist.

      The files names are expected to be normalized.

      Edge cases:
      - A `directory` must not be null: if null, throw IllegalArgumentException
      - A directory does not contain itself: return false
      - A null child file is not contained in any parent: return false
      Parameters:
        `canonicalParent` - the path string to consider as the parent.
        `canonicalChild` - the path string to consider as the child.
      Returns:
        true if the candidate leaf is under the specified composite. False otherwise.
      See Also:
        `FileUtils.directoryContains(File, File)`

    - #### equals

          public static boolean equals(String fileName1,
                                       String fileName2)

      Checks whether two file names are exactly equal.

      No processing is performed on the file names other than comparison. This is merely a null-safe case-sensitive string equality.

      Parameters:
        `fileName1` - the first file name, may be null
        `fileName2` - the second file name, may be null
      Returns:
        true if the file names are equal, null equals null
      See Also:
        `IOCase.SENSITIVE`

    - #### equals

          public static boolean equals(String fileName1,
                                       String fileName2,
                                       boolean normalize,
                                       IOCase ioCase)

      Checks whether two file names are equal, optionally normalizing and providing control over the case-sensitivity.
      Parameters:
        `fileName1` - the first file name, may be null
        `fileName2` - the second file name, may be null
        `normalize` - whether to normalize the file names
        `ioCase` - what case sensitivity rule to use, null means case-sensitive
      Returns:
        true if the file names are equal, null equals null

    - #### equalsNormalized

          public static boolean equalsNormalized(String fileName1,
                                                 String fileName2)

      Checks whether two file names are equal after both have been normalized.

      Both file names are first passed to `normalize(String)`. The check is then performed in a case-sensitive manner.

      Parameters:
        `fileName1` - the first file name, may be null
        `fileName2` - the second file name, may be null
      Returns:
        true if the file names are equal, null equals null
      See Also:
        `IOCase.SENSITIVE`

    - #### equalsNormalizedOnSystem

          public static boolean equalsNormalizedOnSystem(String fileName1,
                                                         String fileName2)

      Checks whether two file names are equal using the case rules of the system after both have been normalized.

      Both file names are first passed to `normalize(String)`. The check is then performed case-sensitively on Unix and case-insensitively on Windows.

      Parameters:
        `fileName1` - the first file name, may be null
        `fileName2` - the second file name, may be null
      Returns:
        true if the file names are equal, null equals null
      See Also:
        `IOCase.SYSTEM`

    - #### equalsOnSystem

          public static boolean equalsOnSystem(String fileName1,
                                               String fileName2)

      Checks whether two file names are equal using the case rules of the system.

      No processing is performed on the file names other than comparison. The check is case-sensitive on Unix and case-insensitive on Windows.

      Parameters:
        `fileName1` - the first file name, may be null
        `fileName2` - the second file name, may be null
      Returns:
        true if the file names are equal, null equals null
      See Also:
        `IOCase.SYSTEM`

    - #### flipSeparator

          static char flipSeparator(char ch)

      Flips the Windows name separator to Linux and vice-versa.
      Parameters:
        `ch` - The Windows or Linux name separator.
      Returns:
        The Windows or Linux name separator.

    - #### getBaseName

          public static String getBaseName(String fileName)

      Gets the base name, minus the full path and extension, from a full file name.

      This method will handle a path in either Unix or Windows format. The text after the last forward or backslash and before the last period is returned.

           a/b/c.txt --> c
           a\b\c.txt --> c
           a/b/c.foo.txt --> c.foo
           a.txt     --> a
           a/b/c     --> c
           a/b/c/    --> ""

      The output will be the same irrespective of the machine that the code is running on.

      Parameters:
        `fileName` - the file name, null returns null
      Returns:
        the name of the file without the path, or an empty string if none exists
      Throws:
        `IllegalArgumentException` - if the file name contains the null character (`U+0000`)

    - #### getExtension

          public static String getExtension(String fileName)
                                     throws IllegalArgumentException

      Gets the extension of a file name.

      This method returns the textual part of the file name after the last period. There must be no directory separator after the period.

           foo.txt      --> "txt"
           a/b/c.jpg    --> "jpg"
           a/b.txt/c    --> ""
           a/b/c        --> ""

      The output will be the same irrespective of the machine that the code is running on, with the exception of a possible `IllegalArgumentException` on Windows (see below).

      Note: This method used to have a hidden problem for names like "foo.exe:bar.txt". In this case, the name wouldn't be the name of a file, but the identifier of an alternate data stream (bar.txt) on the file foo.exe. The method used to return ".txt" here, which would be misleading. Commons IO 2.7 and later throw an `IllegalArgumentException` for names like this.

      Parameters:
        `fileName` - the file name to retrieve the extension of.
      Returns:
        the extension of the file or an empty string if none exists or `null` if the file name is `null`.
      Throws:
        `IllegalArgumentException` - Windows only: the file name parameter is, in fact, the identifier of an Alternate Data Stream, for example "foo.exe:bar.txt".

    - #### getFullPath

          public static String getFullPath(String fileName)

      Gets the full path (prefix + path) from a full file name.

      This method will handle a file in either Unix or Windows format. The method is entirely text based, and returns the text before and including the last forward or backslash.

           C:\a\b\c.txt --> C:\a\b\
           ~/a/b/c.txt  --> ~/a/b/
           a.txt        --> ""
           a/b/c        --> a/b/
           a/b/c/       --> a/b/c/
           C:           --> C:
           C:\          --> C:\
           ~            --> ~/
           ~/           --> ~/
           ~user        --> ~user/
           ~user/       --> ~user/

      The output will be the same irrespective of the machine that the code is running on.

      Parameters:
        `fileName` - the file name, null returns null
      Returns:
        the path of the file, an empty string if none exists, null if invalid
      Throws:
        `IllegalArgumentException` - if the result path contains the null character (`U+0000`)

    - #### getFullPathNoEndSeparator

          public static String getFullPathNoEndSeparator(String fileName)

      Gets the full path (prefix + path) from a full file name, excluding the final directory separator.

      This method will handle a file in either Unix or Windows format. The method is entirely text based, and returns the text before the last forward or backslash.

           C:\a\b\c.txt --> C:\a\b
           ~/a/b/c.txt  --> ~/a/b
           a.txt        --> ""
           a/b/c        --> a/b
           a/b/c/       --> a/b/c
           C:           --> C:
           C:\          --> C:\
           ~            --> ~
           ~/           --> ~
           ~user        --> ~user
           ~user/       --> ~user

      The output will be the same irrespective of the machine that the code is running on.

      Parameters:
        `fileName` - the file name, null returns null
      Returns:
        the path of the file, an empty string if none exists, null if invalid
      Throws:
        `IllegalArgumentException` - if the result path contains the null character (`U+0000`)

    - #### getName

          public static String getName(String fileName)

      Gets the name minus the path from a full file name.

      This method will handle a file in either Unix or Windows format. The text after the last forward or backslash is returned.

           a/b/c.txt --> c.txt
           a\b\c.txt --> c.txt
           a.txt     --> a.txt
           a/b/c     --> c
           a/b/c/    --> ""

      The output will be the same irrespective of the machine that the code is running on.

      Parameters:
        `fileName` - the file name, null returns null
      Returns:
        the name of the file without the path, or an empty string if none exists
      Throws:
        `IllegalArgumentException` - if the file name contains the null character (`U+0000`)

    - #### getPath

          public static String getPath(String fileName)

      Gets the path from a full file name, which excludes the prefix and the name.

      This method will handle a file in either Unix or Windows format. The method is entirely text based, and returns the text before and including the last forward or backslash.

           C:\a\b\c.txt --> a\b\
           ~/a/b/c.txt  --> a/b/
           a.txt        --> ""
           a/b/c        --> a/b/
           a/b/c/       --> a/b/c/

      The output will be the same irrespective of the machine that the code is running on.

      This method drops the prefix from the result. See `getFullPath(String)` for the method that retains the prefix.

      Parameters:
        `fileName` - the file name, null returns null
      Returns:
        the path of the file, an empty string if none exists, null if invalid
      Throws:
        `IllegalArgumentException` - if the result path contains the null character (`U+0000`)

    - #### getPathNoEndSeparator

          public static String getPathNoEndSeparator(String fileName)

      Gets the path (which excludes the prefix) from a full file name, and also excluding the final directory separator.

      This method will handle a file in either Unix or Windows format. The method is entirely text based, and returns the text before the last forward or backslash.

           C:\a\b\c.txt --> a\b
           ~/a/b/c.txt  --> a/b
           a.txt        --> ""
           a/b/c        --> a/b
           a/b/c/       --> a/b/c

      The output will be the same irrespective of the machine that the code is running on.

      This method drops the prefix from the result. See `getFullPathNoEndSeparator(String)` for the method that retains the prefix.

      Parameters:
        `fileName` - the file name, null returns null
      Returns:
        the path of the file, an empty string if none exists, null if invalid
      Throws:
        `IllegalArgumentException` - if the result path contains the null character (`U+0000`)

    - #### getPrefix

          public static String getPrefix(String fileName)

      Gets the prefix such as `C:/` or `~/` from a full file name,

      This method will handle a file in either Unix or Windows format. The prefix includes the first slash in the full file name where applicable.

           Windows:
           a\b\c.txt           --> ""          --> relative
           \a\b\c.txt          --> "\"         --> current drive absolute
           C:a\b\c.txt         --> "C:"        --> drive relative
           C:\a\b\c.txt        --> "C:\"       --> absolute
           \\server\a\b\c.txt  --> "\\server\" --> UNC

           Unix:
           a/b/c.txt           --> ""          --> relative
           /a/b/c.txt          --> "/"         --> absolute
           ~/a/b/c.txt         --> "~/"        --> current user
           ~                   --> "~/"        --> current user (slash added)
           ~user/a/b/c.txt     --> "~user/"    --> named user
           ~user               --> "~user/"    --> named user (slash added)

      The output will be the same irrespective of the machine that the code is running on. ie. both Unix and Windows prefixes are matched regardless.

      Parameters:
        `fileName` - the file name, null returns null
      Returns:
        the prefix of the file, null if invalid
      Throws:
        `IllegalArgumentException` - if the result contains the null character (`U+0000`)

    - #### getPrefixLength

          public static int getPrefixLength(String fileName)

      Returns the length of the file name prefix, such as `C:/` or `~/`.

      This method will handle a file in either Unix or Windows format.

      The prefix length includes the first slash in the full file name if applicable. Thus, it is possible that the length returned is greater than the length of the input string.

           Windows:
           a\b\c.txt           --> 0           --> relative
           \a\b\c.txt          --> 1           --> current drive absolute
           C:a\b\c.txt         --> 2           --> drive relative
           C:\a\b\c.txt        --> 3           --> absolute
           \\server\a\b\c.txt  --> 9           --> UNC
           \\\a\b\c.txt        --> -1          --> error

           Unix:
           a/b/c.txt           --> 0           --> relative
           /a/b/c.txt          --> 1           --> absolute
           ~/a/b/c.txt         --> 2           --> current user
           ~                   --> 2           --> current user (slash added)
           ~user/a/b/c.txt     --> 6           --> named user
           ~user               --> 6           --> named user (slash added)
           //server/a/b/c.txt  --> 9
           ///a/b/c.txt        --> -1          --> error
           C:                  --> 0           --> valid file name as only null character and / are reserved characters

      The output will be the same irrespective of the machine that the code is running on. ie. both Unix and Windows prefixes are matched regardless.

      Note that a leading // (or \\) is used to indicate a UNC name on Windows. These must be followed by a server name, so double-slashes are not collapsed to a single slash at the start of the file name.

      Parameters:
        `fileName` - the file name to find the prefix in, null returns -1
      Returns:
        the length of the prefix, -1 if invalid or null

    - #### indexOfExtension

          public static int indexOfExtension(String fileName)
                                      throws IllegalArgumentException

      Returns the index of the last extension separator character, which is a period.

      This method also checks that there is no directory separator after the last period. To do this it uses `indexOfLastSeparator(String)` which will handle a file in either Unix or Windows format.

      The output will be the same irrespective of the machine that the code is running on, with the exception of a possible `IllegalArgumentException` on Windows (see below).

      Note: This method used to have a hidden problem for names like "foo.exe:bar.txt". In this case, the name wouldn't be the name of a file, but the identifier of an alternate data stream (bar.txt) on the file foo.exe. The method used to return ".txt" here, which would be misleading. Commons IO 2.7, and later versions, are throwing an `IllegalArgumentException` for names like this.
      Parameters:
        `fileName` - the file name to find the last extension separator in, null returns -1
      Returns:
        the index of the last extension separator character, or -1 if there is no such character
      Throws:
        `IllegalArgumentException` - Windows only: the file name parameter is, in fact, the identifier of an Alternate Data Stream, for example "foo.exe:bar.txt".

    - #### indexOfLastSeparator

          public static int indexOfLastSeparator(String fileName)

      Returns the index of the last directory separator character.

      This method will handle a file in either Unix or Windows format. The position of the last forward or backslash is returned.

      The output will be the same irrespective of the machine that the code is running on.

      Parameters:
        `fileName` - the file name to find the last path separator in, null returns -1
      Returns:
        the index of the last separator character, or -1 if there is no such character

    - #### isExtension

          public static boolean isExtension(String fileName,
                                            Collection<String> extensions)

      Checks whether the extension of the file name is one of those specified.

      This method obtains the extension as the textual part of the file name after the last period. There must be no directory separator after the period. The extension check is case-sensitive on all platforms.

      Parameters:
        `fileName` - the file name, null returns false
        `extensions` - the extensions to check for, null checks for no extension
      Returns:
        true if the file name is one of the extensions
      Throws:
        `IllegalArgumentException` - if the file name contains the null character (`U+0000`)

    - #### isExtension

          public static boolean isExtension(String fileName,
                                            String... extensions)

      Checks whether the extension of the file name is one of those specified.

      This method obtains the extension as the textual part of the file name after the last period. There must be no directory separator after the period. The extension check is case-sensitive on all platforms.

      Parameters:
        `fileName` - the file name, null returns false
        `extensions` - the extensions to check for, null checks for no extension
      Returns:
        true if the file name is one of the extensions
      Throws:
        `IllegalArgumentException` - if the file name contains the null character (`U+0000`)

    - #### isExtension

          public static boolean isExtension(String fileName,
                                            String extension)

      Checks whether the extension of the file name is that specified.

      This method obtains the extension as the textual part of the file name after the last period. There must be no directory separator after the period. The extension check is case-sensitive on all platforms.

      Parameters:
        `fileName` - the file name, null returns false
        `extension` - the extension to check for, null or empty checks for no extension
      Returns:
        true if the file name has the specified extension
      Throws:
        `IllegalArgumentException` - if the file name contains the null character (`U+0000`)

    - #### isSystemWindows

          static boolean isSystemWindows()

      Determines if Windows file system is in use.
      Returns:
        true if the system is Windows

    - #### normalize

          public static String normalize(String fileName)

      Normalizes a path, removing double and single period path steps.

      This method normalizes a path to a standard format. The input may contain separators in either Unix or Windows format. The output will contain separators in the format of the system.

      A trailing slash will be retained. A double slash will be merged to a single slash (but UNC names are handled). A single period path segment will be removed. A double period will cause that path segment and the one before to be removed. If the double period has no parent path segment, `null` is returned.

      The output will be the same on both Unix and Windows except for the separator character.

           /foo//               -->   /foo/
           /foo/./              -->   /foo/
           /foo/../bar          -->   /bar
           /foo/../bar/         -->   /bar/
           /foo/../bar/../baz   -->   /baz
           //foo//./bar         -->   //foo/bar
           /../                 -->   null
           ../foo               -->   null
           foo/bar/..           -->   foo/
           foo/../../bar        -->   null
           foo/../bar           -->   bar
           //server/foo/../bar  -->   //server/bar
           //server/../bar      -->   null
           C:\foo\..\bar        -->   C:\bar
           C:\..\bar            -->   null
           ~/foo/../bar/        -->   ~/bar/
           ~/../bar             -->   null

      (Note the file separator will be correct for Windows/Unix.)
      Parameters:
        `fileName` - the file name to normalize, null returns null
      Returns:
        the normalized fileName, or null if invalid
      Throws:
        `IllegalArgumentException` - if the file name contains the null character (`U+0000`)

    - #### normalize

          public static String normalize(String fileName,
                                         boolean unixSeparator)

      Normalizes a path, removing double and single period path steps.

      This method normalizes a path to a standard format. The input may contain separators in either Unix or Windows format. The output will contain separators in the format specified.

      A trailing slash will be retained. A double slash will be merged to a single slash (but UNC names are handled). A single period path segment will be removed. A double period will cause that path segment and the one before to be removed. If the double period has no parent path segment to work with, `null` is returned.

      The output will be the same on both Unix and Windows except for the separator character.

           /foo//               -->   /foo/
           /foo/./              -->   /foo/
           /foo/../bar          -->   /bar
           /foo/../bar/         -->   /bar/
           /foo/../bar/../baz   -->   /baz
           //foo//./bar         -->   /foo/bar
           /../                 -->   null
           ../foo               -->   null
           foo/bar/..           -->   foo/
           foo/../../bar        -->   null
           foo/../bar           -->   bar
           //server/foo/../bar  -->   //server/bar
           //server/../bar      -->   null
           C:\foo\..\bar        -->   C:\bar
           C:\..\bar            -->   null
           ~/foo/../bar/        -->   ~/bar/
           ~/../bar             -->   null

      The output will be the same on both Unix and Windows including the separator character.
      Parameters:
        `fileName` - the file name to normalize, null returns null
        `unixSeparator` - `true` if a Unix separator should be used or `false` if a Windows separator should be used.
      Returns:
        the normalized fileName, or null if invalid
      Throws:
        `IllegalArgumentException` - if the file name contains the null character (`U+0000`)

    - #### normalizeNoEndSeparator

          public static String normalizeNoEndSeparator(String fileName)

      Normalizes a path, removing double and single period path steps, and removing any final directory separator.

      This method normalizes a path to a standard format. The input may contain separators in either Unix or Windows format. The output will contain separators in the format of the system.

      A trailing slash will be removed. A double slash will be merged to a single slash (but UNC names are handled). A single period path segment will be removed. A double period will cause that path segment and the one before to be removed. If the double period has no parent path segment to work with, `null` is returned.

      The output will be the same on both Unix and Windows except for the separator character.

           /foo//               -->   /foo
           /foo/./              -->   /foo
           /foo/../bar          -->   /bar
           /foo/../bar/         -->   /bar
           /foo/../bar/../baz   -->   /baz
           //foo//./bar         -->   /foo/bar
           /../                 -->   null
           ../foo               -->   null
           foo/bar/..           -->   foo
           foo/../../bar        -->   null
           foo/../bar           -->   bar
           //server/foo/../bar  -->   //server/bar
           //server/../bar      -->   null
           C:\foo\..\bar        -->   C:\bar
           C:\..\bar            -->   null
           ~/foo/../bar/        -->   ~/bar
           ~/../bar             -->   null

      (Note the file separator returned will be correct for Windows/Unix)
      Parameters:
        `fileName` - the file name to normalize, null returns null
      Returns:
        the normalized fileName, or null if invalid
      Throws:
        `IllegalArgumentException` - if the file name contains the null character (`U+0000`)

    - #### normalizeNoEndSeparator

          public static String normalizeNoEndSeparator(String fileName,
                                                       boolean unixSeparator)

      Normalizes a path, removing double and single period path steps, and removing any final directory separator.

      This method normalizes a path to a standard format. The input may contain separators in either Unix or Windows format. The output will contain separators in the format specified.

      A trailing slash will be removed. A double slash will be merged to a single slash (but UNC names are handled). A single period path segment will be removed. A double period will cause that path segment and the one before to be removed. If the double period has no parent path segment to work with, `null` is returned.

      The output will be the same on both Unix and Windows including the separator character.

           /foo//               -->   /foo
           /foo/./              -->   /foo
           /foo/../bar          -->   /bar
           /foo/../bar/         -->   /bar
           /foo/../bar/../baz   -->   /baz
           //foo//./bar         -->   /foo/bar
           /../                 -->   null
           ../foo               -->   null
           foo/bar/..           -->   foo
           foo/../../bar        -->   null
           foo/../bar           -->   bar
           //server/foo/../bar  -->   //server/bar
           //server/../bar      -->   null
           C:\foo\..\bar        -->   C:\bar
           C:\..\bar            -->   null
           ~/foo/../bar/        -->   ~/bar
           ~/../bar             -->   null

      Parameters:
        `fileName` - the file name to normalize, null returns null
        `unixSeparator` - `true` if a Unix separator should be used or `false` if a Windows separator should be used.
      Returns:
        the normalized fileName, or null if invalid
      Throws:
        `IllegalArgumentException` - if the file name contains the null character (`U+0000`)

    - #### removeExtension

          public static String removeExtension(String fileName)

      Removes the extension from a fileName.

      This method returns the textual part of the file name before the last period. There must be no directory separator after the period.

           foo.txt    --> foo
           .txt       --> "" (empty string)
           a\b\c.jpg  --> a\b\c
           /a/b/c.jpg --> /a/b/c
           a\b\c      --> a\b\c
           a.b\c      --> a.b\c

      The output will be the same irrespective of the machine that the code is running on.

      Parameters:
        `fileName` - the file name, null returns null
      Returns:
        the file name minus the extension
      Throws:
        `IllegalArgumentException` - if the file name contains the null character (`U+0000`)

    - #### separatorsToSystem

          public static String separatorsToSystem(String path)

      Converts all separators to the system separator.
      Parameters:
        `path` - the path to be changed, null ignored.
      Returns:
        the updated path.

    - #### separatorsToUnix

          public static String separatorsToUnix(String path)

      Converts all separators to the Unix separator of forward slash.
      Parameters:
        `path` - the path to be changed, null ignored.
      Returns:
        the new path.

    - #### separatorsToWindows

          public static String separatorsToWindows(String path)

      Converts all separators to the Windows separator of backslash.
      Parameters:
        `path` - the path to be changed, null ignored.
      Returns:
        the updated path.

    - #### splitOnTokens

          static String[] splitOnTokens(String text)

      Splits a string into a number of tokens. The text is split by '?' and '*'. Where multiple '*' occur consecutively they are collapsed into a single '*'.
      Parameters:
        `text` - the text to split
      Returns:
        the array of tokens, never null

    - #### wildcardMatch

          public static boolean wildcardMatch(String fileName,
                                              String wildcardMatcher)

      Checks a fileName to see if it matches the specified wildcard matcher, always testing case-sensitive.

      The wildcard matcher uses the characters '?' and '*' to represent a single or multiple (zero or more) wildcard characters. This is the same as often found on DOS/Unix command lines. The check is case-sensitive always.

           wildcardMatch("c.txt", "*.txt")      --> true
           wildcardMatch("c.txt", "*.jpg")      --> false
           wildcardMatch("a/b/c.txt", "a/b/*")  --> true
           wildcardMatch("c.txt", "*.???")      --> true
           wildcardMatch("c.txt", "*.????")     --> false

      The sequence "*?" does not work properly at present in match strings.
      Parameters:
        `fileName` - the file name to match on
        `wildcardMatcher` - the wildcard string to match against
      Returns:
        true if the file name matches the wildcard string
      See Also:
        `IOCase.SENSITIVE`

    - #### wildcardMatch

          public static boolean wildcardMatch(String fileName,
                                              String wildcardMatcher,
                                              IOCase ioCase)

      Checks a fileName to see if it matches the specified wildcard matcher allowing control over case-sensitivity.

      The wildcard matcher uses the characters '?' and '*' to represent a single or multiple (zero or more) wildcard characters. The sequence "*?" does not work properly at present in match strings.

      Parameters:
        `fileName` - the file name to match on
        `wildcardMatcher` - the wildcard string to match against
        `ioCase` - what case sensitivity rule to use, null means case-sensitive
      Returns:
        true if the file name matches the wildcard string

    - #### wildcardMatchOnSystem

          public static boolean wildcardMatchOnSystem(String fileName,
                                                      String wildcardMatcher)

      Checks a fileName to see if it matches the specified wildcard matcher using the case rules of the system.

      The wildcard matcher uses the characters '?' and '*' to represent a single or multiple (zero or more) wildcard characters. This is the same as often found on DOS/Unix command lines. The check is case-sensitive on Unix and case-insensitive on Windows.

           wildcardMatch("c.txt", "*.txt")      --> true
           wildcardMatch("c.txt", "*.jpg")      --> false
           wildcardMatch("a/b/c.txt", "a/b/*")  --> true
           wildcardMatch("c.txt", "*.???")      --> true
           wildcardMatch("c.txt", "*.????")     --> false

      The sequence "*?" does not work properly at present in match strings.
      Parameters:
        `fileName` - the file name to match on
        `wildcardMatcher` - the wildcard string to match against
      Returns:
        true if the file name matches the wildcard string
      See Also:
        `IOCase.SYSTEM`